package edu.toronto.cs.ctl;

import java.util.*;

/**
 ** This is an abstract CTL node.
 **/
public abstract class CTLVisitorDefaulterAncestor implements CTLVisitor
{
  public void visit (CTLNode n, Object stateinfo)
  {
    if (n != null)
      n.accept (this, stateinfo);
  }
  
  public void visitCTLNode (CTLNode node, Object stateinfo)
  {
    // Don't panic.
  }

  public void visitAbstractNode (CTLAbstractNode node, Object stateinfo)
  {
    visitCTLNode (node, stateinfo);
  }

  public void visitAFNode (CTLAFNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAGNode (CTLAGNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAUNode (CTLAUNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAUiNode (CTLAUiNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAWNode (CTLAWNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAXNode (CTLAXNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAndNode (CTLAndNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitAtomNode (CTLAtomNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEFNode (CTLEFNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEGNode (CTLEGNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEUNode (CTLEGNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEUiNode (CTLEUiNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEWNode (CTLEWNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEXNode (CTLEXNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitEqualsNode (CTLEqualsNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitIffNode (CTLIffNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitImplNode (CTLImplNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitLatticeNode (CTLLatticeNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitMvSetNode (CTLMvSetNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitNegNode (CTLNegNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitNode (CTLNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitOrNode (CTLOrNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitOverNode (CTLOverNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitPlaceholderNode (CTLPlaceholderNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitPreEXNode (CTLPreEXNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }
  public void visitUnderNode (CTLUnderNode node, Object stateinfo)  { visitCTLNode (node, stateinfo); }

  
}
