package edu.toronto.cs.experiments;

import java.util.*;
import edu.toronto.cs.algebra.*;

public class Lattices 
{

  static String giveSpecific = null;
  static String latticeBaseDir = "play/gxl/";
  static Map lattices = null;
  public static List latticeNames;
  
  static boolean initialized = false;
  public static void initialize() 
  {
    if (lattices != null) return;
    
    lattices = new HashMap();
    try {
      FiniteLattice two = LatticeFactory.parse (latticeBaseDir + 
						 "2val-logic.xml");
      lattices.put("2Bool", two);

      FiniteLattice three = LatticeFactory.parse (latticeBaseDir + 
						 "3val-logic.xml");
      lattices.put("3QBool",
		   LatticeFactory.parse (latticeBaseDir + "3val-logic.xml"));
      lattices.put ("3FTO", lattices.get ("3QBool"));

      FiniteLattice four = LatticeFactory.parse (latticeBaseDir + 
						 "4val-logic.xml");
      lattices.put("4Bool", four);
      lattices.put("4FTO", LatticeFactory.parse (latticeBaseDir + 
					 "4fto-logic.xml"));
      lattices.put("5FTO",
		   LatticeFactory.parse (latticeBaseDir + 
					 "5fto-logic.xml"));
      lattices.put("6Coffee",
		   LatticeFactory.parse (latticeBaseDir + 
					 "coffee-logic.xml"));
      lattices.put("6QBool", new FiniteLattice(two, three));
      lattices.put("6FTO", LatticeFactory.parse (latticeBaseDir + 
					 "6fto-logic.xml"));

      lattices.put ("8Bool", new FiniteLattice (two, four));
      lattices.put("9QBool",
		   LatticeFactory.parse (latticeBaseDir + 
					 "9val-logic.xml"));

      lattices.put("16Bool", new FiniteLattice(four, four));

      lattices.put("16FTO", LatticeFactory.parse (latticeBaseDir + 
						  "16val-logic.xml"));

      latticeNames = new ArrayList ();
      latticeNames.add ("2Bool");
      latticeNames.add ("3QBool");
      //latticeNames.add ("3FTO");
      latticeNames.add ("4Bool");
      latticeNames.add("4FTO");
      latticeNames.add ("5FTO");
      latticeNames.add ("6Coffee");
      latticeNames.add("6QBool");
      latticeNames.add("6FTO");
      latticeNames.add ("8Bool");
      latticeNames.add ("9QBool");
      latticeNames.add ("16Bool");
      latticeNames.add ("16FTO");
      
      initialized = true;
    } 
    catch (Exception e) { 
	e.printStackTrace();
    }

  }

  static
  {
    initialize ();
  }
  

  static void setSpecific (String v)
  {
    giveSpecific = v;
  }
  
  static Collection availableLattices() 
  {
    if (giveSpecific == null)
      {
	return latticeNames;
      }
    else
      {
	Collection c = new ArrayList ();
	c.add (giveSpecific);
	return c;
      }
  }
 

  public static FiniteLattice getLatticeByName (String name) 
  {
    return (FiniteLattice)lattices.get (name);
  }
}

