package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import java.util.Set;
import java.util.HashSet;
import java.util.Map;
import java.util.HashMap;
import java.util.Arrays;
import edu.toronto.cs.mvset.MvSetFactory;
import edu.toronto.cs.algebra.*;

public class StuffFunction extends Function 
{

  int supportLow;
  int supportHigh;

  // -- number of alices
  int n;

  Set entries;

  // -- not needed?
  //Map entryMap;

  /***
   * Arguments: 
   * m_ -- size of the logic
   * k_ -- number of variables
   * sl -- lower limit of support
   * sh -- upper limit of support
   * n_ -- number of Alices
   */
  public StuffFunction (int m_, int k_, int sl, int sh, int n_) 
  {
    super (m_, k_);
    
    System.out.println ("Started SF!");
    supportLow = sl;
    supportHigh = sh;
    n = n_;
    //entries = new HashSet ();
    fill ();
  }

  /** given the support n, choose n variables at random
   *  and assign them values.

   **** Rename minterm into Alice
   */
  protected Object[] minterm (int supp) 
  {
    Set varset = new HashSet ();
    // at outset: all assignments are don't cares
    Object mint [] = new Integer [k];
    
    // XXX Use Algebra.NO_VALUE and fix MvSet -- all of them
    Arrays.fill (mint, new Integer (MvSetFactory.DONT_CARE));
    // pick supp variables at random
    while (varset.size () < supp) {
      int nxt = Chaos.nextUpTo(k);
      if (varset.add (new Integer(nxt)))
	mint[nxt] = new Integer (Chaos.nextUpTo (m));
    }
    return mint;
  }   

  protected boolean addUniqueEntry (Object inp[], int o) 
  {
    Entry e = new Entry (inp, o);
    
    if (entries.contains(e))
      {
	//System.out.println("Clank!");
	return false;
      }
    else {
      //  System.out.println("Adding: "+e.toString());
      entries.add(e);
      return true;
    }
  }

  public void fill () 
  {
    entries = new HashSet ();
    for (int i = 0; i < n; i++) 
      while (!(addUniqueEntry 
	       (minterm (Chaos.inRange (supportLow, supportHigh)),
		Chaos.inRange (1, m))));
				    
	
  }
  public Function clone (int m_, int k_) {
    return new StuffFunction(m_, k_, supportLow, supportHigh, n);
  }

  public Iterator getAllPoints() {
    return entries.iterator();
  }

  /***
   *** Given a new size of the logic and a mapping between current and 
   *** new logic returns the embeding of this function is the new logic
   *** space 
   */
  public Function embed(int newm, int mapping[]) {
    return this;
    // nothing so far!
  }
  public String toString (FiniteLattice lattice)
  {
    StringBuffer sb = new StringBuffer ();
    for (Iterator it = entries.iterator (); it.hasNext (); )
      {
	sb.append (((Entry)it.next ()).toString (lattice));
	sb.append ('\n');
      }
    
	
    return sb.toString ();
  }
  
  public static void main(String argv[]) {
    //StuffFunction sf = new StuffFunction(2, 5, 1, 5, 20);
    StuffFunction sf = new StuffFunction (2, 10, 3, 5, 20);
    System.out.println (sf.toString (Lattices.getLatticeByName ("2Bool")));
    
  }
}


