package edu.toronto.cs.gui;

import edu.toronto.cs.modelchecker.*;

import java.util.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;

/**
 ** The menu for our Model-Checker.
 **/
public class XCMenu extends JMenuBar
{
  // various menus
  JMenu file, model, fairness, ctlhistory, help;

//    JMenuItem open;
  JMenuItem openXML, openBDD, openGeneric;
  //  JMenuItem fairness;
  JMenuItem loadFairness, saveFairness;
  //  JMenuItem ctlhistory;
  JMenuItem loadCTL, saveCTL;
  JMenuItem quit;
  JMenuItem modelInfo;
  JMenuItem variables;
  JMenuItem generalhelp, about;

  /**
   ** Constructs a menu for our model-checker.
   **/
  public XCMenu (ActionMap actionMap)
  {    
    super ();

    file = new JMenu ("File");
    file.setMnemonic (KeyEvent.VK_F);
    model = new JMenu ("Model");
    model.setMnemonic (KeyEvent.VK_M);
    fairness = new JMenu ("Fairness");
    fairness.setMnemonic (KeyEvent.VK_A);
    ctlhistory = new JMenu ("CTL history");
    ctlhistory.setMnemonic (KeyEvent.VK_C);
    help = new JMenu ("Help");
    help.setMnemonic (KeyEvent.VK_H);

    // file menu
//      open = new JMenu ("Open"); // it's a submenu

    // open submenu
    openXML = new JMenuItem ((Action)actionMap.get ("Open XML model..."));
    openXML.setIcon (null);
    openXML.setAccelerator (KeyStroke.getKeyStroke ("alt X"));
    openBDD = new JMenuItem ((Action)actionMap.get ("Open BDD model..."));
    openBDD.setIcon (null);
    openBDD.setAccelerator (KeyStroke.getKeyStroke ("alt B"));
    openGeneric = new JMenuItem ((Action)actionMap.get 
				 ("Open a generic model..."));
    openGeneric.setIcon (null);
    openGeneric.setAccelerator (KeyStroke.getKeyStroke ("alt G"));

    // fairness menu
    loadFairness =
      new JMenuItem ((Action)actionMap.get ("Load fairness conditions"));
    loadFairness.setIcon (null);
    loadFairness.setAccelerator (KeyStroke.getKeyStroke ("F3"));
    saveFairness =
      new JMenuItem ((Action)actionMap.get ("Save fairness conditions"));
    saveFairness.setIcon (null);
    saveFairness.setAccelerator (KeyStroke.getKeyStroke ("F4"));

    // CTL history menu
    loadCTL = new JMenuItem ((Action)actionMap.get ("Load CTL history"));
    loadCTL.setIcon (null);
    loadCTL.setAccelerator (KeyStroke.getKeyStroke ("F5"));
    saveCTL = new JMenuItem ((Action)actionMap.get ("Save CTL history"));
    saveCTL.setIcon (null);
    saveCTL.setAccelerator (KeyStroke.getKeyStroke ("F6"));
    
    // quit
    quit = new JMenuItem ((Action)actionMap.get("Quit"));
    quit.setIcon (null);
    quit.setAccelerator (KeyStroke.getKeyStroke ("alt Q"));
    
    // show model info
    modelInfo = new JMenuItem ((Action)actionMap.get ("Model info"));
    modelInfo.setIcon (null);
    modelInfo.setAccelerator (KeyStroke.getKeyStroke ("alt I"));
    
    // show variables
    variables = new JMenuItem ((Action)actionMap.get ("Show variables"));
    variables.setIcon (null);
    variables.setAccelerator (KeyStroke.getKeyStroke ("alt V"));

    // help, about...
    generalhelp = new JMenuItem ((Action)actionMap.get ("Help"));
    generalhelp.setIcon (null);
    generalhelp.setAccelerator (KeyStroke.getKeyStroke ("F1"));
    about = new JMenuItem ((Action)actionMap.get ("About"));
    about.setIcon (null);
    
    // to the File menu add the submenu add - Open XML, Open BDD, Open generic
    file.add (openXML);
    file.add (openBDD);
    file.add (openGeneric);

    // to the Fairness menu add - load ans save fairness
    fairness.add (loadFairness);
    fairness.add (saveFairness);

    // to the CTL menu add - load ans save CTL history
    ctlhistory.add (loadCTL);
    ctlhistory.add (saveCTL);

    // to the File nemu add - a separetor
    file.add (new JSeparator ());
 
    // to the File menu add - Quit
    file.add (quit);

    // to the Model menu add - Model info and variables
    model.add (modelInfo);
    model.add (variables);

    help.add (generalhelp);
    help.add (about);
    
    add (file);
    add (model);
    add (fairness);
    add (ctlhistory);
    add (help);
  }

}






