package edu.toronto.cs.lift;

import edu.toronto.cs.smv.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.algebra.*;

public class MButton extends SMVModule
{
  static final int PRESSED = 0;
  static final int REQUEST = 1;

  MvSet reset = null;

  int maybe = -2;
  
  public MButton (String _name)
  {
    super (_name);
    vars = new String[]{"pressed", "request"};
  }
  

  public void setReset (MvSet v)
  {
    reset = v;
  }
  
  
  public MvSet computeTrans ()
  {
    System.out.println ("Computing trans for: " + getName ());
    return computeRequest ().and (computePressed ());
  }
  

  public void setLattice (FiniteLattice lattice)
  {
    super.setLattice (lattice);
    maybe = lattice.getElementIdxByKey ("M");
  }

  public MvSet computePressed ()
  {
    /* next(pressed) := case
                       request : M;
		       1: {true, false}
    */

    return new CaseStatement ().
      addCase (cur (REQUEST), next (PRESSED, maybe)).
      addDefault (next (PRESSED, top).or (next (PRESSED, bot))).compute ();
  }
  
  public MvSet computeRequest ()
  {

    MvSet requestIsRequest = 
      ddManager.createProjection (getVarOrder (REQUEST)).eq
      (ddManager.createProjection (getNextVarOrder (REQUEST)));
    /**
     * request := case
     *             reset : false;
                   pressed: true;
		   1 : request
    */

    return new CaseStatement ().
      addCase (reset, next (REQUEST, bot)).
      addCase (cur (PRESSED), next (REQUEST)).
      addDefault (requestIsRequest).compute ();
  }

  

  public MvState initializeInitState (MvState initState)
  {
    initState.setValue (getVarOrder (PRESSED), maybe);
    initState.setValue (getVarOrder (REQUEST), bot);
    return initState;
  }
  
    
}
