package edu.toronto.cs.mdd;

//import edu.toronto.cs.MDD.MDDCacheEntry;

/** This interface defines a cache for MDDNode operation results.
    I can't specify it here, but all operations should be
    <b>synchronized.</b> */
public interface MDDNodeCache 
{
  

  MDDNode find (MDDNode m1, int oper, Object data);
  /** find unary operation result */
  MDDNode find(MDDNode m1, int oper);
  /** find binary operation result */
  MDDNode find(MDDNode m1, MDDNode m2, int oper);
   
  void insert (MDDNode m1, int oper, Object data, MDDNode result);
  /** insert unary operation result */
  void insert(MDDNode m1, int oper, MDDNode result);
  /** insert binary operation result */
  void insert(MDDNode m1, MDDNode m2, int oper, MDDNode result);

  /** explicitly tell cache to clean up old entries. */
  void cleanup();
  void resetStats ();
}
