package edu.toronto.cs.prettygraph;

import java.util.*; // We all love java.util ...
import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.keg.*;

// NOTE: This visitor requires a BREADTH FIRST traversal...
// NOTE: This visitor will fail on graphs which are not trees.
public class KEGTreeRanger extends DGTreeRanger 
  implements PrettyGraphVisitor
{
  public KEGTreeRanger ()
  {
  }

  public void visitPrettyGraphNode (PrettyGraphNode node, Object stateinfo)
  {
  }

  public void visit (DGNodeVisitable node, Object stateinfo)
  {
    if (node instanceof PrettyGraphNode)
      ((PrettyGraphNode)node).accept (this, stateinfo);
    else
      node.accept (this, stateinfo);
  }

  public void visitDGUniqueNode (DGUniqueNode node, 
				 Object stateinfo)
  {
    super.visitDGNode (node, stateinfo);
  }

  public void visitDGNode (DGNode node, Object stateinfo)
  {
    super.visitDGNode (node, stateinfo);
  }
  
  public void visitPrettyKegGraphNode 
    (PrettyKegGraphNode node, Object stateinfo)
  {
    super.visitDGNode (node, stateinfo);
    // This makes sure that even the rootnodes get entries...  
    if (!super.nodeToIndex.containsKey (node))
	nodeToIndex.put (node, new Integer (0));
    int currentIndex = ((Integer)nodeToIndex.get (node)).intValue ();
    if (!(node.getKegNode () instanceof KEGCtlNode))
      currentIndex++;
    for (Iterator it = node.getSuccessors ().iterator (); it.hasNext ();)
      {
	DGNode nnode = (DGNode) it.next ();
	nodeToIndex.put (nnode, new Integer (currentIndex));
      }
    
  }

  public void visitPrettyXKNode (PrettyGraphXKNode node, Object stateinfo)
  {
  }
  

  public void visitPrettyGraphMDDNode 
    (PrettyGraphMDDNode node, Object stateinfo)
  {
  }

  public Object getStateInfo (DGNode node)
  {
    List l = new LinkedList ();
    l.add (nodeToPedigree.get (node));
    Assert.assert (nodeToPedigree.get (node) != null);
    l.add (nodeToIndex.get (node));
    return l;
  }

}

 
  
