package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.modelchecker.*;

public class PrettyBaseKegLabel
{
  Set desiredProps;
  MvState state;
  PropOrderIf props;
  String banner;
  String footer;

  public PrettyBaseKegLabel (PropOrderIf _props, 
			     String _banner, String _footer, 
			     MvState _state)
  {
    banner = _banner;
    footer = _footer;
    desiredProps = new HashSet ();
    props = _props;
    state = _state;
  }

  public PrettyBaseKegLabel (PropOrderIf _props, String _banner,
			     MvState state)
  {
    this (_props, _banner, ".\n", state);
  }
  
  public PrettyBaseKegLabel (PropOrderIf _props, MvState _state)
  {
    this (_props, "", ".\n", _state);
  }

  public PrettyBaseKegLabel addToDesired (int i)
  {
    desiredProps.add (new Integer (i));
    return this;
  }
  
  public PrettyBaseKegLabel addToDesired (Set s)
  {
    for (Iterator it = s.iterator (); it.hasNext ();)
      desiredProps.add ((Integer)it.next ());
    return this;
  }
  
  public PrettyBaseKegLabel removeFromDesired (int i)
  {
    desiredProps.remove (new Integer (i));
    return this;
  }

  public PrettyBaseKegLabel removeFromDesired (Set s)
  {
    for (Iterator it = s.iterator (); it.hasNext ();)
      removeFromDesired (((Integer)it.next ()).intValue ());
    return this;
  }
  
  public PrettyBaseKegLabel setBanner (String s)
  {
    banner = s;
    return this;
  }

  public PrettyBaseKegLabel setFooter (String s)
  {
    footer = s;
    return this;
  }
  
  public String toString ()
  {
    Assert.assert (props != null, "Argl -- props null!");
    StringBuffer sb = new StringBuffer ();
    sb.append (banner);
    if (banner != "")
      sb.append ('\n');
    for (Iterator it = desiredProps.iterator (); it.hasNext ();)
      {
	int i = ((Integer)it.next ()).intValue ();
	
	sb.append (state.getPropString 
		   (i, props));
	if (it.hasNext ())
	  sb.append ('\n');
      }
    if (!footer.equals (""))
      {
	sb.append ('\n');
	sb.append (footer);
      }
    return sb.toString ();
  }
}

    
      
  
  
  

