package edu.toronto.cs.prettygraph;

import java.util.*;
import java.awt.Color;

import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;



public class PrettyConstants
{
  // General
  static final String EDGE_CONNECT = "-->>";
  static final String CTL_CONNECT = "_";
  static final String STATE_CONNECT = "->";
  static final String CTL_TYPE = "KCtlNode";
  static final String ST_TYPE = "KStateNode";

  // shape
  static final int BOX_SHAPE = 1;
  static final int CIRCLE_SHAPE = 2;

  // linestyle
  static final int DOUBLE_LINE = 1;
  static final int SINGLE_LINE = 2;
  
  static final int DOTTED_LINE = 1;
  static final int SOLID_LINE = 2;
  static final int NO_LINE =3;
  
  static final int THICK_LINE = 1;
  static final int THIN_LINE = 2;
 
  // Arrow heads
  static final int POINTY_ARROW = 1;
  static final int ROUND_ARROW = 2;
  static final int POINTY_FILLED_ARROW = 3;
  static final int ROUND_FILLED_ARROW =4;
  static final int IROQUAIAN = 5;
  
  public static final Color defaultColour = Color.black;

  public static Map singletonMap;

  static
  {
        // -- XXX Shameless hack
    singletonMap = new HashMap ();
    singletonMap.put ("T", Color.black);
    singletonMap.put ("M", Color.blue);
    singletonMap.put ("S", Color.green);
    singletonMap.put ("DN", Color.orange);
    singletonMap.put ("DK", Color.orange);
    singletonMap.put ("DC", Color.red);
    singletonMap.put ("SN", new Color (128, 0, 128));
    singletonMap.put ("F",  Color.gray);

    singletonMap.put ("0", Color.black);
    singletonMap.put ("1", Color.red);
    singletonMap.put ("2", Color.green);
    singletonMap.put ("3", Color.blue);

    singletonMap.put ("FF", Color.black);
    singletonMap.put ("TF", Color.red);
    singletonMap.put ("FT", Color.green);
    singletonMap.put ("TT", Color.blue);

    singletonMap.put ("TTTT", Color.blue);
    singletonMap.put ("FFFF", Color.orange);
  }
  
}








