package edu.toronto.cs.prettygraph;

import java.util.*; // We all love java.util

import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.keg.*;

public class PrettyStateHistorian extends PrettyGraphVisitorAncestor
  implements DGStateInfoSource
{
  Map nodeToPedigree;
  
  public PrettyStateHistorian ()
    {
      nodeToPedigree = new HashMap ();
    }

  public void visitPrettyKegGraphNode (PrettyKegGraphNode node, 
				       Object stateinfo)
    {
      
      // This makes sure that even the rootnodes get entries...
      if (!nodeToPedigree.containsKey (node))
	nodeToPedigree.put (node, new ArrayList ());
      
      // Go through, and add this node to each of its children's pedigree
      // IF this is a kstate node
      if (node.getKegNode () instanceof KEGStateNode)
	for (Iterator it = node.getSuccessors ().iterator (); it.hasNext ();)
	  {
	    DGNode nnode = (DGNode) it.next ();
	    if (!nodeToPedigree.containsKey (nnode))
	      nodeToPedigree.put (nnode, new ArrayList ());
	    List l = (List) nodeToPedigree.get (nnode);
	    l.add (node);
	  }
      // else, we can do nothing...
    }
  
  public Map getPedigreeMap ()
    {
      return nodeToPedigree;
    }

  public Object getStateInfo (DGNode node)
  {
    return nodeToPedigree.get (node);
  }
}

  
  
  
