package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;

public class SensibleFairCTLToString extends SensibleCTLToStringVisitor
{

  protected SensibleFairCTLToString ()
  {
    super ();
  }
  
  public static String getSensibleString (CTLNode n, Object stateinfo)
  {
    SensibleFairCTLToString v = new SensibleFairCTLToString ();
    v.visit (n, stateinfo);
    return v.getStringBuffer (n).toString ();
  }

  protected void doForEveryNode (CTLNode node, Object stateinfo)
  {
    super.doForEveryNode (node, stateinfo);
    StringBuffer sb = (StringBuffer) nodesToStrings.get (node);
    if (node.getFairness ().size () != 0)
      {
	sb.append ("+{");
	sb.append (node.getFairness ());
	sb.append ('}');
      }
    nodesToStrings.put (node, sb);
  }
}


  
  
