package edu.toronto.cs.util;

/***
 *** Assert.java -- assertion support
 ***/

public class Assert
{

  public static void assert (boolean cond)
  {
    assert (cond, "");
  }
  
  public static void assert (boolean cond, String message)
  {
    if (!cond)
      throw new AssertionFailedException (message);
  }
  public static void assert (String message)
  {
    assert (false, message);
  }
  
  public static void assert (String message, Exception ex)
  {
    throw new AssertionFailedException (message, ex);
  }
  
  public static void assert (Exception ex)
  {
    throw new AssertionFailedException (ex);
  }
  

  // -- test method
  public static void main (String[] args)
  {
    Assert.assert (true, "Should not happen");
    Assert.assert (false, "Wow!");
  }
  

  public static class AssertionFailedException extends NestedRuntimeException
  {
    public AssertionFailedException ()
    {
      super (null);
    }
    public AssertionFailedException (String message)
    {
      super (message, null);
    }
    public AssertionFailedException (String message, Exception ex)
    {
      super (message, ex);
    }
    public AssertionFailedException (Exception ex)
    {
      super (ex);
    }
    
  }
  
}
