package edu.toronto.cs.util;

import java.util.*; // We all love java.util ...

public class StringUtil
{
  public static Map ordinals = new HashMap ();
  
  static
  {
    ordinals.put (new Integer (1), "First");
    ordinals.put (new Integer (2), "Second");
    ordinals.put (new Integer (3), "Third");
    ordinals.put (new Integer (4), "Fourth");
  }
  
  public static final String EmptyString = "";
  
  public static String quote (String s)
  {
    return '"'+s+'"';
  }

  public static String maxLength (String subject, int length, String elipses)
  {
    if (subject.length () <= length)
      return subject;

    StringBuffer sb = new StringBuffer ();
    sb.append (subject.substring (0, length-1));
    sb.append (elipses);
    return sb.toString ();
  }
  
  
  public static StringBuffer quote (StringBuffer s)
  {
    s.insert (0, '"');
    s.append ('"');
    return s;
  }

  public static String ordinate (int i, String zeroth, Map ords)
  {
    if (i == 0)
      return zeroth;
    String s = (String) ords.get (new Integer (i));
    if (s != null)
      return s;
    else
      return ""+i+"th";
  }
  
  public static String ordinate 
    (int i, String zeroth)
  {
    return ordinate (i, zeroth, ordinals);
  } 

  public static String doEscapes (String s)
  {
    Map replacements = new HashMap ();
    replacements.put ("\n", "\\n");
    replacements.put ("\t", "\\t");
    replacements.put ("\\", "\\\\");
    return  translate (replacements, s);
  }

  public static String translate (Map translation, String string)
  {
    StringBuffer sb = new StringBuffer ();
    int last = -1;
    for (int i = 0;i < string.length (); i++)
      {
	String str = (String) translation.get (""+string.charAt (i));
	if (str != null)
	  {
	    if (last+1<i)
	      sb.append (string.substring (last+1, i));
	    last = i;
	    sb.append (str);
	  }
      }
    sb.append (string.substring (last+1));
    return sb.toString ();
  }
  
  public static String replace (String old, String newS, String subject, boolean caseSensitive)
  {
    StringBuffer sb = new StringBuffer ();
    int i=0;
    while (i <= subject.length () - old.length ())
      {
	if (subject.regionMatches (caseSensitive, i, old, 0, old.length ()))
	  {
	    sb.append (newS);
	    i = i+old.length ();
	  }
	else
	  {
	    sb.append (subject.substring(i,i+1));
	    i++;
	  }
      }
    if (i<subject.length ())
      sb.append (subject.substring (i, subject.length ()-1));
    return sb.toString ();
  }

  public static void main (String args [])
  {
    System.out.println (quote (args[0]));
    //System.out.println (escapeBSlash (args[1]));
    System.out.println ("\\ Hello World! \\Hi");
    System.out.println (doEscapes("\\ Hello World! \\Hi"));
  }
  
}


