package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...

import edu.toronto.cs.util.*;

/** DGNode with some sort of unique identifier...
    @author CDTW */
public class DGUniqueNode extends DGNode
{
  static Logger log = new Logger ("DGUniqueNode");
  
  Map allChildren;
  Object identifier;

  public DGUniqueNode (DGNodeFactory owner)
  {
    super (owner);
    allChildren = new HashMap ();
  }

  public DGUniqueNode (Object ident, DGNodeFactory owner)
  {
    this (owner);
    identifier = ident;
  }

  public void addSuccessor (DGNode successor)
  {
    if (checkValid (successor))
      {
	super.doAddition (successor);
	allChildren.put (((DGUniqueNode)successor).getIdent (), successor);
      }
  }

  public boolean sameIdent (DGUniqueNode node)
  {
    return node.getIdent ().equals (this.getIdent ());
  }
  
  public Object getIdent ()
  {
    return identifier;
  }
  
  
  public Map getChildMap ()
  {
    return allChildren;
  }

  public void accept (DGraphVisitor visitor, Object stateinfo)
  {
    log.debug ("VISIT DGUN by DGV");
    visitor.visitDGUniqueNode (this, stateinfo);
  }
  
}

