package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...


/** DGNode with equals...
    @author CDTW */
public class DGUniqueNodeFactory extends DGNodeFactory
{
  public DGUniqueNodeFactory ()
  {
  }
  
  public DGUniqueNode createNode (Object ident)
  {
    return obtainNode (null, ident);
  }

  public DGUniqueNode createNode (DGUniqueNode target, Object ident)
  {
    return obtainNode (target, ident);
  }

  public DGUniqueNode instantNode (Object ident)
  {
    return new DGUniqueNode (ident, this);
  }

  public DGUniqueNode obtainNode (DGUniqueNode target, Object ident)
    {
      Map allChildren;
      if (target!=null)
	{
	  allChildren = target.getChildMap ();
	}
      else
	{
	  allChildren = new HashMap ();
	}

      if (allChildren.containsKey (ident))
	return ((DGUniqueNode)allChildren.get (ident));
      
      DGUniqueNode returnNode = instantNode (ident);
      allChildren.put (ident, returnNode);
      
      return returnNode;
    }
}
