package edu.toronto.cs.xkripke;

import java.util.*;

import edu.toronto.cs.util.*;
import edu.toronto.cs.mvset.MvState;


public class XKDepthTraverse
{
  static Logger log = new Logger ("XKDepthTraverse");

  List nodes;

  public static Iterator getIterator (XKripke.XKripkeState xk)
  {
    log.debug ("Start Hi!");
    XKDepthTraverse di = new XKDepthTraverse (xk);
    return di.getIterator ();
  }

  public static Iterator getIterator (XKripke xk)
  {
    log.debug ("Start Hi!");
    XKDepthTraverse di = new XKDepthTraverse (xk);
    return di.getIterator ();
  }
 
  private XKDepthTraverse (XKripke xk)
  { 
    nodes = new ArrayList ();
    XKripke.XKripkeState [] states = xk.getInitialStates ();
    for (int i = 0; i<states.length; i++ )
      {
	XKripke.XKripkeState next = states [i];
	nodes.add(next);
	log.debug ("   Hi!:"+next);
	doChildrenOf (next);
      }
  }

  private XKDepthTraverse (XKripke.XKripkeState xk)
  {
    nodes = new ArrayList ();
    nodes.add (xk);
    doChildrenOf (xk);
  }
  
  private void doChildrenOf (XKripke.XKripkeState state)
  {
    for (Iterator it = getSuccessors (state).iterator (); it.hasNext ();)
      {
	XKripke.XKripkeState next = (XKripke.XKripkeState) it.next ();
	if (!nodes.contains (next))
	  {
	    nodes.add (next);
	    log.debug ("       Hi!: "+next);
	    doChildrenOf (next);
	  }
      }
  }

  private Set getSuccessors (XKripke.XKripkeState state)
  {
    log.debug ("Getting successors for "+state.getName ());
    XKripke xk = state.getXKripke ();
    Set transitions = xk.getTransitions ();
    Set result = new HashSet ();
    for (Iterator it = transitions.iterator (); it.hasNext ();)
      {
	XKripke.XKripkeTransition trans = 
	  (XKripke.XKripkeTransition) it.next ();
	//log.debug ("Doing transition from "
	//	   +trans.getSrc ().getName ()+" to "
	//	   +trans.getDst ().getName ()+".");
	if (trans.getSrc () == state)
	  {
	    //log.debug ("--Adding!");
	    result.add (trans.getDst ());
	  }
      }
    return result;
  }
  
  public Iterator getIterator ()
  {
    return nodes.iterator ();
  }
  
}
